// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*************************************************************************
 * @file SimplePublisher.h
 * This header file contains the declaration of the publisher functions.
 *
 * This file was generated by the tool fastrtpsgen.
 */


#ifndef _Simple_PUBLISHER_H_
#define _Simple_PUBLISHER_H_

#include "fastrtps/rtps_all.h"

class SimplePublisher 
{
public:
	SimplePublisher();
	virtual ~SimplePublisher();
	bool init();
	void run();
private:
	RTPSParticipant *mp_RTPSParticipant;
	Publisher *mp_publisher;
	
	class PubListener : public PublisherListener
	{
	public:
		PubListener() : n_matched(0){};
		~PubListener(){};
		void onPublicationMatched(MatchingInfo info);
		int n_matched;
	} m_listener;
};

#endif // _Simple_PUBLISHER_H_
