// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*************************************************************************
 * @file SimpleSubscriber.h
 * This header file contains the declaration of the subscriber functions.
 *
 * This file was generated by the tool fastrtpsgen.
 */


#ifndef _Simple_SUBSCRIBER_H_
#define _Simple_SUBSCRIBER_H_

#include "fastrtps/rtps_all.h"

class SimpleSubscriber 
{
public:
	SimpleSubscriber();
	virtual ~SimpleSubscriber();
	bool init();
	void run();
private:
	RTPSParticipant *mp_RTPSParticipant;
	Subscriber *mp_subscriber;
	
	class SubListener : public SubscriberListener
	{
	public:
		SubListener() : n_matched(0){};
		~SubListener(){};
		void onSubscriptionMatched(MatchingInfo info);
		void onNewDataMessage();
		SampleInfo_t m_info;
		Subscriber* mp_sub;
		int n_matched;
	} m_listener;
};

#endif // _Simple_SUBSCRIBER_H_
